/******************************************************************************
Module:  LSAStr.h
Notices: Copyright (c) 2000 Jeffrey Richter
******************************************************************************/
#include "StdAfx.h"
#include "LSASTR.H"

CLSAStr::CLSAStr() { ResetInstance(TRUE); }
CLSAStr::CLSAStr(PWSTR pstr) {
      ResetInstance(TRUE);
      AssignString(pstr);      
   }
CLSAStr::CLSAStr(LSA_UNICODE_STRING &lsastr) {
      ResetInstance(TRUE);
      AssignLSAStr(&lsastr);      
   }
CLSAStr::CLSAStr(PLSA_UNICODE_STRING plsastr) {
      ResetInstance(TRUE);
      AssignLSAStr(plsastr);      
   }
CLSAStr::CLSAStr(CLSAStr &lsaStr) {
      ResetInstance(TRUE);
      AssignLSAStr(&lsaStr);      
   }

CLSAStr::~CLSAStr() { ResetInstance(FALSE); }

//   operator PWSTR() {return(Buffer); }
//   operator =(LSA_UNICODE_STRING &lsastr) { AssignLSAStr(&lsastr); }
//   operator =(PLSA_UNICODE_STRING plsastr) { AssignLSAStr(plsastr); }
//   operator =(PWSTR pstr) { AssignString(pstr); }

void CLSAStr::ResetInstance(BOOL fConstructing) {
      if (!fConstructing && Buffer)
         HeapFree(GetProcessHeap(), 0, Buffer);
      Buffer = NULL;
      Length = MaximumLength = 0;      
   }

void CLSAStr::AssignString(PWSTR pstr) {
      USHORT nLength = (USHORT)(lstrlen(pstr) * sizeof(WCHAR));
      if (AdjustBuffer((USHORT) (nLength + sizeof(WCHAR)))) {
         lstrcpy(Buffer, pstr);
         Length = nLength;         
      }      
   }

void CLSAStr::AssignLSAStr(PLSA_UNICODE_STRING plsastr) {
      if (AdjustBuffer((USHORT) (plsastr->Length + sizeof(WCHAR)))) {
         CopyMemory(Buffer, plsastr->Buffer, plsastr->Length);
         Length = plsastr->Length;
         Buffer[Length / sizeof(WCHAR)] = 0;         
      }
   }

BOOL CLSAStr::AdjustBuffer(USHORT nMax) {
      BOOL fReturn = FALSE;
      if (MaximumLength < nMax) {
         ResetInstance();
         Buffer = (WCHAR*) HeapAlloc(GetProcessHeap(), 0, nMax);
         if (Buffer) {
            MaximumLength = nMax;
            fReturn = TRUE;
         }
      } else fReturn = TRUE;
      return(fReturn);
   }



///////////////////////////////// End of File /////////////////////////////////