#include "stdafx.h"
#include "ListCtrlEx.h"

/////////////////////////////////////////////////////////////////////////////
// CListCtrlEx

BOOL CListCtrlEx::AddColumn(LPCTSTR strItem,int nItem,int nSubItem,int nMask,int nFmt)
{
	LV_COLUMN lvc;
	lvc.mask = nMask;
	lvc.fmt = nFmt;
	lvc.pszText = (LPTSTR) strItem;
	lvc.cx = GetStringWidth(lvc.pszText) + 15;
	if(nMask & LVCF_SUBITEM){
		if(nSubItem != -1)
			lvc.iSubItem = nSubItem;
		else
			lvc.iSubItem = nItem;
	}
	return InsertColumn(nItem,&lvc);
}

BOOL CListCtrlEx::DeleteColumnEx(LPCTSTR strItem)
{
	//iterate the head to locate the index
	int nCol = 0;
	int index = -1;
	while(1)
	{
		LVCOLUMN col;
        col.mask = LVCF_TEXT;
		CString str;
		col.pszText = str.GetBuffer(50);
		col.cchTextMax = 50;
	    if(!GetColumn(nCol, &col))
		{
			str.ReleaseBuffer(0);
			break;
		}	
		
		//int len = str.GetLength();
		//str.ReleaseBuffer(len);
		str.ReleaseBuffer(50);
		str.TrimRight();
        if(str == strItem)
		{
			index = nCol;
			break;
		}
        nCol++;
	}
	if(index == -1) return FALSE;
	else return DeleteColumn(index);	
}

BOOL CListCtrlEx::DeleteAllColumn()
{
	int count = GetColumnCount();
	while(count >= 1)
	{
		DeleteColumn(count - 1);
		count--;
	}
	return TRUE;
}

int  CListCtrlEx::GetColumnIndex(LPCTSTR strItem)
{
	//iterate the head to locate the index
	int nCol = 0;
	int index = -1;
	while(1)
	{
		LVCOLUMN col;
        col.mask = LVCF_TEXT;
		CString str;
		col.pszText = str.GetBuffer(50);
		col.cchTextMax = 50;
	    if(!GetColumn(nCol, &col))
		{
			str.ReleaseBuffer(0);
			break;
		}	
		
		//int len = str.GetLength();
		//str.ReleaseBuffer(len);
		str.ReleaseBuffer(50);
		str.TrimRight();
        if(str == strItem)
		{
			index = nCol;
			break;
		}
        nCol++;
	}
	return index;
}

int  CListCtrlEx::GetColumnCount()
{
	int count = 0;
	while(1)
	{
		LVCOLUMN col;
        col.mask = LVCF_TEXT;
		CString str;
		col.pszText = str.GetBuffer(50);
		col.cchTextMax = 50;
	    if(!GetColumn(count, &col))
		{
			str.ReleaseBuffer(0);
			return count;
		}	
		
		//int len = str.GetLength();
		//str.ReleaseBuffer(len);
		str.ReleaseBuffer(50);
		count++;
	}
}

BOOL CListCtrlEx::GetColumnText(CString& str, int index)
{
	if(index < 0 || index >= GetColumnCount()) return FALSE; 
	LVCOLUMN col;
    col.mask = LVCF_TEXT;
	col.pszText = str.GetBuffer(50);
	col.cchTextMax = 50;
	if(!GetColumn(index, &col))
	{
		str.ReleaseBuffer(0);
		return FALSE;
	}	
	str.ReleaseBuffer(50);
	return TRUE;
}

BOOL CListCtrlEx::AddItem(int nItem,int nSubItem,LPCTSTR strItem,int nImageIndex)
{
	LV_ITEM lvItem;
	lvItem.mask = LVIF_TEXT;
	lvItem.iItem = nItem;
	lvItem.iSubItem = nSubItem;
	lvItem.pszText = (LPTSTR) strItem;
	if(nImageIndex != -1){
		lvItem.mask |= LVIF_IMAGE;
		lvItem.iImage = nImageIndex;
	}
	if(nSubItem == 0)
		return InsertItem(&lvItem);
	return SetItem(&lvItem);
}
/*
CString CListCtrlEx::GetItemText(int nItem,int nSubItem)
{
	LV_ITEM lvItem;
	lvItem.mask = LVIF_TEXT;
	lvItem.iItem = nItem;
	lvItem.iSubItem = nSubItem;
	GetItem(&lvItem);
	return lvItem.pszText;
}*/
/////////////////////////////////////////////////////////////////////////////
